//   ( , ):
void cls(unsigned char, unsigned char);

//   (X,Y,):
void PaintSym(unsigned char, unsigned char, unsigned char);

//   (X,Y,  , ):
void PaintSq(unsigned char, unsigned char, unsigned char, unsigned char);

//      1    (  ):
unsigned char* UpLine(unsigned char *);

//      1    (  ):
unsigned char* DownLine(unsigned char *);

//        (X,Y):
unsigned char* Attr2Bitmap(unsigned char, unsigned char);

//     4x4  (X, Y, ):
void InitSQUARE(unsigned char, unsigned char, unsigned char);

//   (  ,    ):
void PutNum(unsigned char *, unsigned char *);

//   (X,Y,   ,    ):
void Print16(unsigned char, unsigned char, unsigned char, unsigned char *);

//       0  15:
unsigned char RND_4(void);

//    :
unsigned char inkey(void);

//   "2"  -    :
void addnum(void);

#define MaxSQ  16 	//      .
#define This_x  2	//    .
#define This_y  2

//   32x16x2c    (2 - 8192):
#include "Nums_V_rastr.c" 
//    :	     0      2 	   4      8
static const unsigned char colors[14] = {13<<3,  7<<3, 	5<<3,  6<<3,
//										    16	   32	  64	128
										  4<<3,  3<<3,  2<<3, 10<<3,
//										   256	  512   1024   2048
										 14<<3, 11<<3, 12<<3, 15<<3,
//										  4096	 8192
										  9<<3,  1<<3};
										  
unsigned char FreeSQ;       //      .
unsigned char S[4][4]; //      4x4. 
										  
void main(void)
{
unsigned char i,k,l,c;
l;

	FreeSQ = MaxSQ;
	
	cls(0,colors[1]);
	InitSQUARE(This_x, This_y, colors[3]);
	for(i=0;i<4;i++) {for(k=0;k<4;k++)S[i][k]=0;};
	
	if(FreeSQ != 0) addnum();
	   FreeSQ--;
	if(FreeSQ != 0) addnum();
	   FreeSQ--;
	   
	while(1)
	{
	switch(inkey())
		{
		case 'Q': {	
					for(k=0;k<4;k++)
					{	
						l = 0;
						for(i=0;i<4;i++)
						{
							if(!S[i+l][k]) l++;
							S[i][k] = S[i+l][k];
							S[i+l][k] = 0;
							c = S[i][k];
							PaintSq(This_x+4*k, This_y+i*4,   4, colors[c]);
							Print16(This_x+k*4, This_y+i*4+1, c, Nums_V_rastr);
							
						};
					};
				  }; break;
				  
		case 'A': { for(k=0;k<4;k++)
					{	
						l = 0;
						for(i=3;i>0;i--)
						{
							if(!S[i-l][k]) l++;
							S[i][k] = S[i-l][k];
							S[i-l][k] = 0;
						};
					};		
		
		
				  }; break;
		case 'O': {	
				  }; break;
		case 'P': {	
				  }; break;
				  
		default :   break;
		}
		
		
	};
}

void addnum(void)
{
	unsigned char i,k;
		do
		{	i = RND_4();
			k = i/4;
			i = i&0x03;
		} 	while(S[i][k]!=0);
			S[i][k]=1;
			PaintSq(This_x+4*k, This_y+i*4,   4, colors[1]);
			Print16(This_x+k*4, This_y+i*4+1, 1, Nums_V_rastr);
}

void Print16(unsigned char x, unsigned char y, unsigned char sym, unsigned char *font)
{
	unsigned char * pos;
	unsigned char * num;
	pos = Attr2Bitmap(x,y);
	num = (unsigned char*)font+sym*64;
	PutNum(pos,num);
	
}

void InitSQUARE(unsigned char _x, unsigned char _y, unsigned char Color)
{
	unsigned char k,i;
	unsigned char *scr;
	PaintSq(_x,_y,16,Color);
		
	for(i=0;i<5;i++)
	{
		scr = Attr2Bitmap(_x+(i*4)-1,_y);
		for(k=0; k<128; k++)
		{
			*scr = 0x01;
			scr=DownLine(scr);
		};
	};
	
	for(i=0;i<5;i++)
	{
		scr = Attr2Bitmap(_x,_y+i*4);
		for(k=0; k<16; k++)
		{
			*scr = 0xff;
			scr++;
		};
	};

}	

void PaintSq(unsigned char x, unsigned char y, unsigned char len, unsigned char Color)
{
	unsigned char i,k;
	for(k=0; k<len;k++)
	{
		for(i=0; i<len; i++) PaintSym(x+i,y,Color);
		y++;
	};
}

void PaintSym(unsigned char x, unsigned char y, unsigned char Color)
{ x,y,Color;
__asm
	ld	hl,#2
	add	hl,sp
	ld	c,(hl)
	inc hl
	ld	b,(hl)
	inc	hl
	ld	a,(hl)
	ld	de,#0x5800
	ld	h,e ; 0
	ld	l,b
	add hl,hl
	add hl,hl
	add	hl,hl
	add hl,hl
	add hl,hl
	add	hl,de
	ex	de,hl
	ld	h,#0
	ld	l,c
	add	hl,de
	and	a,#0x7f
	ld	(hl),a
__endasm;	
}

void cls(unsigned char Fill, unsigned char Color)
{ Fill; Color;
__asm
	ld	hl,#2
	add	hl,sp
	ld	a,(hl)
	ld	de,#0x4000
	ld	(de),a
	inc	hl
	ld	a,(hl)
	ld	hl,#0x4001
	ex	de,hl
	ld	bc,#0x17ff
	ldir
	inc	de
	inc hl
	ld	bc,#0x2ff
	ld	(hl),a
	ldir
__endasm;
}

unsigned char* DownLine(unsigned char *ptr) __naked
{ ptr;
__asm
	ld 	hl,#2
	add hl,sp
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
     inc h
     ld a,h
     and a,#7
     jr nz,1$ ;cy=0
     ld a,l
     add a,#32
     ld l,a
     jr c,1$  ;cy=1
     ld a,h
     add a,#-8
     ld h,a   ;cy=1
1$:	ret
__endasm;
}

unsigned char* UpLine(unsigned char * ptr) __naked
{ ptr;
__asm
	ld	hl,#3
	add	hl,sp
	ld	a,(hl)
	dec	hl
	ld	l,(hl)
	ld	h,a
     LD A,H
     DEC H
     AND #7
     ret z
     LD A,L
     SUB a,#32
     LD L,A
     ret c
     LD A,H
     ADD A,#8
     LD H,A
	 ret
__endasm;
}

unsigned char* Attr2Bitmap(unsigned char x, unsigned char y) __naked
{ x,y;
__asm
	ld	hl,#2
	add	hl,sp
	ld	e,(hl)
	inc hl
	ld	d,(hl)
; D = Y character position
; E = X character position
; Returns address in DE
; Title:    ZX Spectrum Standard Output Routines
; Author:   Dean Belfield
; Created:  29/07/2011
; Last Updated: 02/07/2012

	ld a,d
	and #7
	rra
	rra
	rra
	rra
	or a,e
	ld e,a
	ld a,d
	and a,#0x18
	or  a,#0x40
	ld d,a
	ex de,hl
	ret
__endasm;
}

void PutNum(unsigned char *dest, unsigned char *num)
{ dest, num;
__asm
	ld hl,#2
	add hl,sp
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld b,#16
2$:	push de
	ldi
	ldi
	ldi
	ldi
	pop de
	 inc d
     ld a,d
     and a,#7
     jr nz,1$ ;cy=0
     ld a,e
     add a,#32
     ld e,a
     jr c,1$  ;cy=1
     ld a,d
     add a,#-8
     ld d,a   ;cy=1
1$:	djnz 2$
__endasm;
}

unsigned char RND_4(void) __naked
{
__asm
1$:	LD A,#53
	ADD A,A
	JR NC,2$
	LD C,a
	XOR A,C
2$:	LD C,A
	LD A,R
	XOR A,C 
	LD (1$+1),A
	ld	c,a
	rrca
	rrca
	rrca
	rrca
	xor a,c
	and	a,#0x0f
	ld	l,a
	ret
__endasm;	
}
unsigned char inkey(void) __naked
{
__asm
	ld a,(0x5c04) ; BASIC var
	ld	l,a
	ld	a,#0xff
	ld	(0x5c04),a
	ret
__endasm;
}